# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

#TODO: BR: perl(Test::Pod::No404s) when available

# We need to patch the test suite if we have an old version of Test::More
%global test_more_lt096 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.96) ? 1 : 0);' 2>/dev/null || echo 0)
%global test_more_lt094 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.94) ? 1 : 0);' 2>/dev/null || echo 0)
%global test_more_lt088 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)
%global test_more_lt082 %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.82) ? 1 : 0);' 2>/dev/null || echo 0)

# We can do without Test::CheckDeps ≥ 0.007
%global old_test_checkdeps %(perl -MTest::CheckDeps -e 'print (($Test::CheckDeps::VERSION < 0.007) ? 1 : 0);' 2>/dev/null || echo 0)

# Select the appropriate system speller
%if %(perl -e 'print (($] >= 5.010000) ? 1 : 0);')
%global speller hunspell
%else
%global speller aspell
%endif

Name:		perl-namespace-autoclean
Version:	0.15
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Summary:	Keep imports out of your namespace
Source0:	http://search.cpan.org/CPAN/authors/id/E/ET/ETHER/namespace-autoclean-%{version}.tar.gz
Patch0:		namespace-autoclean-0.14-tm096.patch
Patch1:		namespace-autoclean-0.15-tm094.patch
Patch2:		namespace-autoclean-0.15-tm088.patch
Patch3:		namespace-autoclean-0.15-tm082.patch
Patch5:		namespace-autoclean-0.14-pod-spell.patch
URL:		http://search.cpan.org/dist/namespace-autoclean
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	perl(Module::Build::Tiny) >= 0.030
# Module
BuildRequires:	perl(B::Hooks::EndOfScope) >= 0.12
BuildRequires:	perl(Class::MOP) >= 0.80
BuildRequires:	perl(List::Util)
BuildRequires:	perl(namespace::clean) >= 0.20
# Test Suite
BuildRequires:	perl(CPAN::Meta)
BuildRequires:	perl(CPAN::Meta::Requirements)
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(Moose) >= 0.56
BuildRequires:	perl(Moose::Role)
BuildRequires:	perl(Sub::Name)
BuildRequires:	perl(Test::More) >= 0.47
# Extra Tests
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Pod::Coverage::TrustPod)
# Test::CPAN::Changes only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::CPAN::Changes) >= 0.19
%endif
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Kwalitee)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Mojibake)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling), %{speller}-en
BuildRequires:	perl(Test::Version)
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
When you import a function into a Perl package, it will naturally also be
available as a method. The 'namespace::autoclean' pragma will remove all
imported symbols at the end of the current package's compile cycle. Functions
called in the package itself will still be bound by their name, but they won't
show up as methods on your class or instances. This module is very similar to
namespace::clean, except it will clean all imported functions, no matter if you
imported them before or after you 'use'd the pragma. It will also not touch
anything that looks like a method, according to
'Class::MOP::Class::get_method_list'.

%prep
%setup -q -n namespace-autoclean-%{version}

# We don't really need Test::More ≥ 0.96
%if %{test_more_lt096}
%patch0
%endif

# We don't really need Test::More ≥ 0.94
%if %{test_more_lt094}
%patch1
%endif

# We don't really need Test::More ≥ 0.88
%if %{test_more_lt088}
%patch2
%endif

# We don't really need Test::More ≥ 0.82
%if %{test_more_lt082}
%patch3
%endif

# Code examples in Pod can confuse spell checker
%patch5

%build
perl Build.PL --installdirs=vendor
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0

%check
./Build test

# Author/Release tests
%if 0%{!?perl_bootstrap:1}
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
prove -Ilib $(echo $(find xt/ -name '*.t'))
%else
prove -Ilib $(echo $(find xt/ -name '*.t' | grep -Fv cpan-changes.t))
%endif
%endif

%files
%defattr(-,root,root,-)
%doc Changes CONTRIBUTING LICENSE README README.md
%{perl_vendorlib}/namespace/
%{_mandir}/man3/namespace::autoclean.3pm*

%changelog
* Sun Dec 15 2013 Paul Howarth <paul@city-fan.org> - 0.15-1
- Update to 0.15
  - Update configure_requires checking in Makefile.PL, add CONTRIBUTING file
- Update patches as needed

* Wed Oct  9 2013 Paul Howarth <paul@city-fan.org> - 0.14-1
- Update to 0.14
  - Bump dependency on B::Hooks::EndOfScope, to get the separation of pure-perl
    and XS components (CPAN RT#89245)
  - Repository migrated to the github moose organization
- This release by ETHER -> update source URL
- Switch to Module::Build::Tiny flow
- Add build requirements for extra tests and run them except when bootstrapping
- Add a series of patches to support building with old versions of Test::More

* Thu Jul 25 2013 Paul Howarth <paul@city-fan.org> - 0.13-6
- Perl 5.18 rebuild

* Sat Jun 29 2013 Paul Howarth <paul@city-fan.org> - 0.13-5
- Import from Fedora

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.13-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.13-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jun 22 2012 Petr Pisar <ppisar@redhat.com> - 0.13-2
- Perl 5.16 rebuild

* Sat Jan 14 2012 Iain Arnell <iarnell@gmail.com> - 0.13-1
- Update to latest upstream version

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.12-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Thu Jul 21 2011 Petr Sabata <contyk@redhat.com> - 0.12-3
- Perl mass rebuild

* Tue Jul 19 2011 Petr Sabata <contyk@redhat.com> - 0.12-2
- Perl mass rebuild

* Sun Mar 13 2011 Iain Arnell <iarnell@gmail.com> 0.12-1
- Update to latest upstream version
- Clean up spec for modern rpmbuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.11-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Dec 21 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.11-2
- Rebuild to fixing problems with vendorarch/lib (#661697)

* Tue May 04 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.09-4
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.09-3
- Rebuild against perl 5.10.1

* Thu Sep 17 2009 Stepan Kasal <skasal@redhat.com> 0.09-2
- Fix the previous changelog entry

* Wed Sep 16 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.09-1
- Add %%perl_default_filter'ing
- Auto-update to 0.09 (by cpan-spec-update 0.01)
- Added a new req on perl(B::Hooks::EndOfScope) (version 0.07)
- Added a new req on perl(Class::MOP) (version 0.80)
- Added a new req on perl(List::Util) (version 0)
- Added a new req on perl(namespace::clean) (version 0.11)

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.08-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul 01 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08-1
- Submission

* Wed Jul 01 2009 Chris Weyl <cweyl@alumni.drew.edu> 0.08-0
- Initial RPM packaging
- Generated with cpan2dist (CPANPLUS::Dist::RPM version 0.0.8)
